Attribute VB_Name = "ibvbModule"
'-------------------------------------------------------------------------
'Copyright (C) 2001 Dallas Semiconductor Corporation, All Rights Reserved.
'
'Permission is hereby granted, free of charge, to any person obtaining a
'copy of this software and associated documentation files (the "Software"),
'to deal in the Software without restriction, including without limitation
'the rights to use, copy, modify, merge, publish, distribute, sublicense,
'and/or sell copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following conditions:
'
'The above copyright notice and this permission notice shall be included
'in all copies or substantial portions of the Software.
'
'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
'OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'IN NO EVENT SHALL DALLAS SEMICONDUCTOR BE LIABLE FOR ANY CLAIM, DAMAGES
'OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
'ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.
'
'Except as contained in this notice, the name of Dallas Semiconductor
'shall not be used except as stated in the Dallas Semiconductor
'Branding Policy.
'

Global lastError As String
Global access As OneWireAccessProvider
Global adapter As Object

'// debounce array
Global Debounce(100) As Integer

'
' Get the default 1-Wire adapter
' Return 'true' if the adapter was created and 'false' if it had and error
'    The global string 'lastError' is set if there is an error
'
Function GetOWAPIAdapter() As Boolean

    On Error GoTo ErrorTrap
    
    Set adapter = access.getDefaultAdapter()
    
    GetOWAPIAdapter = True
    
    Exit Function

ErrorTrap:
    lastError = Err.Description
    GetOWAPIAdapter = False

End Function

'
' Convert the provided byte array to a hex string
'
Function ToHexStr(ByRef buf, ByVal offset As Integer, ByVal length As Integer) As String
    Dim tstr As String
    Dim I As Integer
    
    tstr = ""
    
    For I = 0 To length - 1
        If (buf.getAt(I + offset) And &HFF) < 16 Then
            tstr = tstr + "0"
        End If
        tstr = tstr + Hex$(buf.getAt(I + offset) And &HFF)
    Next I
    
    ToHexStr = tstr
End Function
